package com.engine.aisin.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.aisin.service.AccessCustomService;
import com.engine.aisin.service.impl.AccessCustomServiceImpl;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/11/15 3:05 PM
 * @Description: TODO
 * @Version 1.0
 */
public class AccessCustomAction {

    private AccessCustomService getService(User user) {
        return  ServiceUtil.getService(AccessCustomServiceImpl.class, user);
    }


    @GET
    @Path("/custom/access")
    @Produces(MediaType.TEXT_PLAIN)
    public String customAccess(@Context HttpServletRequest request, @Context HttpServletResponse response, @QueryParam("userId")String userId){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).customAccess(userId));
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/kqstatistics/access")
    @Produces(MediaType.TEXT_PLAIN)
    public String getKqAccess(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).getKqAccess(ParamUtil.request2Map(request)));
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
